#include "nano-X.h"
#include <stdio.h>

GR_SCREEN_INFO si;
GR_GC_ID gid;

int
main()
{
  int n;
  FILE *file;
  GR_EVENT event;
  GR_FONTID fontid;
  char buffer[128];

  if (GrOpen() < 0) {
	fprintf(stderr, "cannot open graphics\n");
	exit(1);
  }

  gid = GrNewGC ();
  GrGetScreenInfo (&si);

  GrSetGCBackground (gid, WHITE);
  GrSetGCUseBackground(gid, FALSE);
  GrFillRect (GR_ROOT_WINDOW_ID, gid, 0, 0, 640, 480);

  if ((file = fopen("ftdemo.txt", "r")) == NULL)
  {
	printf("Can't open text file\n");
	return (-1);
  }

  n = 0;
  /*if(utf8_fgetws(buffer, 128, file) != NULL)*/
  if(fgets(buffer, 128, file) != NULL)
  {
  	for (n = 0; n < 128 && buffer[n]; n++) {
		if (buffer[n] == '\n')
			break;
	}
  }
  fclose(file);

// Draw arrow
  GrSetGCForeground (gid, BLACK);
  GrLine (GR_ROOT_WINDOW_ID, gid, 310, 240, 330, 240);
  GrLine (GR_ROOT_WINDOW_ID, gid, 320, 230, 320, 250);

#if HAVE_T1LIB_SUPPORT
#define FONTNAME "bchr"
//#define FONTNAME "bchb"
//#define FONTNAME "dcr10"
//#define FONTNAME "dcbx10"
#elif HAVE_FREETYPE_SUPPORT
#define FONTNAME "fonts/lt1-r-omega-serif.ttf"
//#define FONTNAME "fonts/times.ttf"
//#define FONTNAME "fonts/cour.ttf"
#else
#define FONTNAME FONT_SYSTEM_VAR
#endif
  GrSetGCFont(gid, fontid = GrCreateFont(FONTNAME, 36, NULL));
  GrSetFontAttr(fontid, TF_KERNING | TF_ANTIALIAS);
  GrSetFontRotation(fontid, 330);	/* 33 degrees*/
  GrText(GR_ROOT_WINDOW_ID, gid, 320, 240, buffer, n, TF_UTF8);

  while (1)
    GrCheckNextEvent (&event);
  GrClose ();

  return 0;
}
