/* wintern.h*/
/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Microwindows internal routines header file
 */
#if (UNIX | DOS_DJGPP)
#define strcmpi	strcasecmp
#endif

#ifdef __PACIFIC__
#include <string.h>
#define strcmpi		stricmp
#endif  

#ifdef DOS_TURBOC
#include <string.h>
#endif  

#define DBLCLICKSPEED	450		/* mouse dblclick speed in msecs*/

/* non-win32 api access for microwin*/
BOOL		WndSetDesktopWallpaper(PIMAGEHDR pImage);
void		WndRegisterFdInput(HWND hwnd,int fd);
void		WndUnregisterFdInput(HWND hwnd,int fd);
void		WndRegisterFdOutput(HWND hwnd,int fd);
void		WndUnregisterFdOutput(HWND hwnd,int fd);
void		WndRegisterFdExcept(HWND hwnd,int fd);
void		WndUnregisterFdExcept(HWND hwnd,int fd);

/* internal routines*/

/* winuser.c*/
PWNDCLASS 	WndFindClassByName(LPCSTR lpClassName);
void		WndDestroyWindow(HWND hwnd,BOOL bSendMsg);
HWND		WndGetTopWindow(HWND hwnd);
void		WndCalcClientRect(HWND hwnd, DWORD dwStyle);
void		WndSendSizeMove(HWND hwnd, BOOL bSize, BOOL bMove);
void		WndSetCursor(HWND wp, PSWCURSOR pcursor);

/* wingdi.c*/
#define WndIsClientDC(hdc)	(((hdc)->flags & DCX_WINDOW) == 0)
#define WndIsMemDC(hdc)		((hdc)->psd->flags == PSF_MEMORY)
HWND		WndPrepareDC(HDC hdc);
void		WndSetClipWindow(HDC hdc);

/* winexpos.c*/
void		WndRedrawScreen(void);
void		WndHideWindow(HWND hwnd,BOOL bChangeFocus,BOOL bSendMsg);
void		WndShowWindow(HWND hwnd,BOOL bSendMsg);
void		WndRaiseWindow(HWND hwnd);
void		WndLowerWindow(HWND hwnd);
BOOL		WndCheckOverlap(HWND topwp, HWND botwp);
void		WndClearWindow(HWND wp,COORD x,COORD y,COORD width,COORD height,
			BOOL exposeflag);
void		WndExposeArea(HWND wp, COORD rootx,COORD rooty,COORD width,
			COORD height);
/* winevent.c*/
BOOL		GsCheckMouseEvent(void);
BOOL		GsCheckKeyboardEvent(void);
void 		GsHandleMouseStatus(COORD newx, COORD newy, BUTTON newbuttons);
void		WndTranslateMouseMessage(HWND hwnd,UINT msg,int hittest);
void		GsDeliverMouseEvent(BUTTON buttons, BUTTON changebuttons,
			MODIFIER modifiers);
void		GsDeliverKeyboardEvent(UCHAR ch, MODIFIER modifiers);
void		GsDeliverExposureEvent(HWND wp, COORD x, COORD y, COORD width,
			COORD height);
void		WndUnionUpdateRegion(HWND wp, COORD x, COORD y, COORD width,
			COORD height, BOOL bUnion);
void		GsMoveCursor(COORD x, COORD y);
void		GsCheckCursor(void);
HWND		WndFindVisibleWindow(COORD x, COORD y);
void		GsCheckMouseWindow(void);
int		strzcpy(char *dst,const char *src,int dstsiz);

/* winmain.c*/
int		GsOpen(void);
void		GsClose(void);
void		GsSelect(void);
int		GsInitialize(void);
void		GsTerminate(void);
extern	HWND	listwp;			/* list of all windows */
extern	HWND	rootwp;			/* root window pointer */
extern	HWND	focuswp;		/* focus window for keyboard */
extern	HWND	mousewp;		/* window mouse is currently in */
extern	HWND	capturewp;		/* capture window*/
extern  HWND	dragwp;			/* window user is dragging*/
extern	HCURSOR	curcursor;		/* currently enabled cursor */
extern	COORD	cursorx;		/* x position of cursor */
extern	COORD	cursory;		/* y position of cursor */
extern	SCREENINFO	sinfo;		/* screen information */
extern  DWORD	startTicks;		/* tickcount on startup */
extern  int	paintNC;		/* experimental nonclient regions*/
extern  BOOL	forceNCpaint;		/* force NC paint for alphablend*/

#if VTSWITCH
/* temp framebuffer vt switch stuff at upper level
 * this should be handled at the lower level, just like vgalib does.
 */
void fb_InitVt(void);
int  fb_CurrentVt(void);
int  fb_CheckVtChange(void);
void fb_RedrawVt(int t);
void fb_ExitVt(void);
extern int vterm;
#endif /* VTSWITCH*/
